import pycurl
import urllib
import xmltodict
import time
import traceback
import threading
from StringIO import StringIO

try:
    from urllib.parse import urlencode
except ImportError:
    from urllib import urlencode
    
class ARDISubscription:
    def __init__(self,core):
        self.core = core
        self.subscription = ""
        self.codes = []
        self.cancelled = False
        self.codechange = False
        self.threaded = True
        self.callback = None

    def AddCode(self,address):
        self.codes.append(address)
        self.codechange = True

    def Connect(self):
        self.ThreadBody()

    def Subscribe(self):
        self._call("subscribe")
        self.codechange = False
        if self.subscription != "":
            return True
        
        return False

    def Unsubscribe(self):
        self._call("unsubscribe")
        self.subscription = ""
        pass

    def Update(self):
        if self.codechange == True:
            self.Unsubscribe()
            self.Subscribe()
            return
        self._call("update")
        pass

    def _call(self,function):
        print "Calling Consolidator " + function
        try:
            print "  CURL Request"
            fullurl = self.core.server
            try:
                ps = fullurl.index(':')
                if ps > -1:
                    fullurl = fullurl[0:ps]
            except:
                pass

            try:
                ps = fullurl.index('/')
                if ps > -1:
                    fullurl = fullurl[0:ps]
            except:
                pass

            fullurl = "http://" + fullurl
            fullurl += ":" + self.core.contexts[0].consolidator
            fullurl += "/" + function

            anydata = False
            post_data = {}
            if function != "subscribe":
                post_data['id'] = self.subscription

            codelist = ""
            for itm in self.codes:
            	print "Loading Code..."
            	if codelist != "":
            	    codelist = codelist + ","
            	codelist += itm
            	anydata = True

            post_data['codes'] = codelist
            if anydata == True:
                postfields = urlencode(post_data)

                #print fullurl
                #print str(postfields)

                try:
                    response = StringIO()
                    
                    c = pycurl.Curl()
                    c.setopt(c.URL,fullurl)
                    c.setopt(c.WRITEFUNCTION,response.write)
                    c.setopt(c.TIMEOUT,25)
                    c.setopt(c.CONNECTTIMEOUT,5)
                    c.setopt(c.POSTFIELDS,postfields)
                    c.perform()
                    c.close()

                    print response.getvalue()

                    result = xmltodict.parse(response.getvalue())
                    self.subscription = result['update']['id']
                    print 'Subscription ID = ' + self.subscription
                except:
                    print "Failed To Send!"
                    traceback.print_exc()
                    pass
            return True
        except:
            traceback.print_exc()
            return False

    def ThreadBody(self):
        while self.cancelled == False:
            while self.subscription == "":
                if self.Subscribe() == False:
                    time.sleep(5)
                    if self.cancelled == True:
                        break;
                else:
                    break
            if self.cancelled == True:
                break;

            if self.Update():
                #Call the callback function with our new data...
                time.sleep(1)
                pass
            else:
                #No new data arrived - immediately try again.
                pass